#include <s1c33cpu.h>
#include <string.h>
#include <stdio.h>
#include <piece.h>
#include "mmc_api.h"

#define PDWAIT	(*(volatile unsigned char*)0x1000000)	/* p[_Ê߂̃EFCg̈ */
#define P0D	(*(volatile unsigned char*)0x00402D1)	/* P0o͌p|[gf[^WX^ */
#define MMC_RECV_TIMEOUT	0xFFFFF			/* M^CAEgl */

void
mmcByteSend(int data)
{
	volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;
	//
	int i;

	i = 8;
	do {

		if(data & 0x80) {
			/* NbNLowɁB(P06Low) */
			*p0d = lo1;
			*pdwait = 0; /* NbN̂ŃEGCg(1KvB0ȉłُ͈퓮) */

			/* NbNHighɁB(P06High) */
			*p0d = hi1; /* f[^=1 */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */

		} else {
			/* NbNLowɁB(P06Low) */
			*p0d = lo0;
			*pdwait = 0; /* NbN̂ŃEGCg(1KvB0ȉłُ͈퓮) */

			/* NbNHighɁB(P06High) */
			*p0d = hi0; /* f[^=0 */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
			*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
		}

		/* ̂߂Ƀf[^VtgB */
		data <<= 1;

	} while(--i);
}

unsigned char
mmcRecvData(unsigned char* buf, int len)
{
	volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	//const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;
	//
	int v;
	int i;

	/* 0oCgMv͕sȃNGXgłB */
	if(len <= 0) {
		return 0;
	}

	/* X^[grbg(0)܂ő҂B */
	i = MMC_RECV_TIMEOUT;
	for(;;) {

		/* NbNLowɁB(P06Low) */
		*p0d = lo1;
		*pdwait = 0; /* NbN̂ŃEGCg(1KvB0ȉłُ͈퓮) */

		/* NbNHighɁB(P06High) */
		*p0d = hi1;
		*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
		*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
		*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
		*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */
		*pdwait = 0; /* NbN̂ŃEGCg(5KvB4ȉłُ͈퓮) */

		/* f[^擾(P04f[^擾)B */
		if(!(*p0d & 0x10)) {
			break; /* X^[grbg(0)o */
		}

		/* ^CAEg0ԂB */
		if(!--i) {
			return 0;
		}
	}

	/* R1 or R2X|XMH */
	if(len <= 2) {
		/* 1rbgMς݂ɁB */
		v = 0;
		goto R1_R2;
	}

	/* ̃f[^MB */
	do {
		/* 1oCg=8rbg̃f[^M܂B
		 * Ȃ̓NbNLowAHǐ̃EFCgłlMł܂B
		 * f[^]n܂AMMC̕GȏȂ邩ł傤H
		 */
		v = 0;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x80;
R1_R2:		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x40;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x20;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x10;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x08;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x04;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x02;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x01;
		*buf++ = v;

	} while(--len);

	return 1;
}
//---------------------------------------------------------------------------
